OpenVDB 12.1.0

Loading...
Searching...
No Matches
Keyword Struct Reference

Keywords represent keyword statements defining changes in execution. These include those that define changes in loop execution such as break and continue, as well as return statements. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for Keyword:

## Public Types
using | UniquePtr = std::unique_ptr<Keyword>
enum | NodeType { TreeNode , StatementListNode , BlockNode , ConditionalStatementNode , CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode , CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode , CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode , DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode , ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node , ValueFloatNode , ValueDoubleNode , ValueStrNode }
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions
| Keyword (const tokens::KeywordToken keyw)
| Construct a new Keyword with a given tokens::KeywordToken.
| Keyword (const Keyword &other)
| Deep copy constructor for a Keyword.
| ~Keyword () override=default
Keyword * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const Statement * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
size_t | children () const override final
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Node * | child (const size_t) const override final
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
tokens::KeywordToken | keyword () const
| Query the keyword held on this node.
Name/Type
template<typename NodeT>
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
virtual bool | replacechild (const size_t index, Node *node)
| Virtual method that attempted to replace a child at a given index with a provided node type.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Detailed Description

Keywords represent keyword statements defining changes in execution. These include those that define changes in loop execution such as break and continue, as well as return statements.

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Node>
| inherited

## ◆ UniquePtr

using UniquePtr = std::unique_ptr<Keyword>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType
| inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ◆ Keyword() [1/2]

Keyword | ( | const tokens::KeywordToken | keyw | ) |
| inline

Construct a new Keyword with a given tokens::KeywordToken.

Parameters

  keyw | The keyword token.

## ◆ Keyword() [2/2]

Keyword | ( | const Keyword & | other | ) |
| inline

Deep copy constructor for a Keyword.

Parameters

  other | A const reference to another Keyword to deep copy

## ◆ ~Keyword()

~Keyword | ( |  | ) |
| override default

## Member Function Documentation

## ◆ basetype()

const Statement * basetype | ( |  | ) | const
| inline override virtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Node.

## ◆ child()

const Node * child | ( | const size_t |  | ) | const
| inline final override virtual

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Implements Node.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inline inherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)

Returns
  The child index of this node

## ◆ children()

size_t children | ( |  | ) | const
| inline final override virtual

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Implements Node.

## ◆ copy()

Keyword * copy | ( |  | ) | const
| inline final override virtual

The deep copy method for a Node.

Implements Statement.

## ◆ isType()

template<typename NodeT>

bool isType | ( |  | ) | const
| inline inherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ keyword()

tokens::KeywordToken keyword | ( |  | ) | const
| inline

Query the keyword held on this node.

Returns
  The keyword as a tokens::KeywordToken

## ◆ nodename()

const char * nodename | ( |  | ) | const
| inline override virtual

Virtual method for accessing node name information.

Implements Node.

## ◆ nodetype()

NodeType nodetype | ( |  | ) | const
| inline override virtual

Virtual method for accessing node type information.

Implements Node.

## ◆ parent()

const Node * parent | ( |  | ) | const
| inline inherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inline inherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | index,
|  | Node * | node )
| inline virtual inherited

Virtual method that attempted to replace a child at a given index with a provided node type.

Note
  See Node::replace for a more detailed description

Parameters

  index | The child index where a replacement should be attempted
  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, false otherwise

Reimplemented in ArrayPack, ArrayUnpack, AssignExpression, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, FunctionCall, Loop, StatementList, TernaryOperator, and UnaryOperator.

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inline inherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ subname()

const char * subname | ( |  | ) | const
| inline override virtual

Virtual method for accessing node name information.

Implements Node.